/**
 * $Id: OrderedSetAsSetFactoryWithComp.java,v 1.1 2006/01/31 18:27:41 uwe Exp $
 */
package de.fhw.data.set.referenceImpl;

import de.fhw.data.function.Fct2;
import de.fhw.data.set.Set;
import de.fhw.data.set.SetFactory;

/**
 * A concrete factory for ordered set implementations via normal sets.
 * 
 * @param <E> the element type
 */

public
class OrderedSetAsSetFactoryWithComp<E>
implements SetFactory<E> {
	final SetFactory<E> sf;
	final Fct2<E,E,Integer> cp;
	/**
	 * 
	 * @param sf the factory for the underlying set implementation.
	 */
	public OrderedSetAsSetFactoryWithComp(Fct2<E,E,Integer> cp, SetFactory<E> sf) {
		this.cp = cp;
		this.sf = sf;
	}
	/**
	 * the default set factory is for the reference implementation
	 * in de.fhw.data.set.referenceImpl, a very inefficient one
	 *
	 */
	public OrderedSetAsSetFactoryWithComp(Fct2<E,E,Integer> cp) {
		this(cp, new SetAsMapFactory<E>());
	}
	/**
	 * generation of an empty set. The result can be used as a prototype.
	 */
	public Set<E> empty() {
		return
		new OrderedSetAsSetImpl<E>(cp,sf);
	}
}
