/**
 * 
 */
package de.fhw.data.set.referenceImpl;

import de.fhw.data.function.Fct;
import de.fhw.data.function.Fct2;
import de.fhw.data.set.OrderedSetImpl;
import de.fhw.data.set.Set;
import de.fhw.data.set.SetFactory;
import de.fhw.data.tuple.Pair;

/**
 * @author uwe
 *
 */
public
class OrderedSetAsSetImpl<E>
extends OrderedSetImpl<E> {
	final SetFactory<E> sf;
	final Set<E> s;
	
	OrderedSetAsSetImpl(Fct2<E,E,Integer> c, SetFactory<E> sf, Set<E> s) {
		super(c);
		this.sf = sf;
		this.s  = s;
		++newSet;
	}
	OrderedSetAsSetImpl(Fct2<E,E,Integer> c, SetFactory<E> sf) {
		this(c,sf,sf.empty());
	}
	
	/**
	 * generate a new empty set
	 */
	public Set<E> empty() {
		if (isEmpty())
			return this;
		return
		new OrderedSetAsSetImpl<E>(compare,sf);
	}
	
	/**
	 * reimplement isEmpty for efficiency
	 */
	@Override
	public boolean isEmpty() {
		return
		s.isEmpty();
	}
	
	public Set<E> insert(E e) {
		if (s.contains(e))
			return this;
		return
		new OrderedSetAsSetImpl<E>(compare,sf,s.insert(e));
	}
	
	@Override
	public Set<E> remove(E e) {
		if (! s.contains(e))
			return this;
		return
		new OrderedSetAsSetImpl<E>(compare,sf,s.remove(e));
	}
	
	/**	
	 * choose1 implemeted with set choose
	 */
	@Override
	public E choose1() {
		return s.choose();
	}
	
	public
	<R>
	R fold(final Fct2<E,R,R> f, R init) {
		return s.fold(f,init);
	}
	
	// TODO this declaration leads to error: method becomes ambiguous
	/**
	 * Ecipse bug: The method is ambiguous for the type ...
	 * 
	 * If bug is removed, delete this wrapper method
	 */
	
	public
	<R>
	R foldMap(
			final Fct2<R,R,R> combine,
			final Fct<E,R> map,
			R init) {
		return s.foldMap(combine,map,init);
		// return eclipseBugFoldMap(combine,map,init);
	}
	// TODO this declaration leads to error: method becomes ambiguous
	/**
	 * Ecipse bug: The method is ambiguous for the type ...
	 * 
	 * If bug is removed, delete this wrapper method
	 */
	public
	<R>
	R fold1Map(
			final Fct2<R,R,R> combine,
			final Fct<E,R> map,
			R emptyRes) {
		return s.fold1Map(combine,map,emptyRes);
	}
	
	public boolean inv() {
		return s.inv();
	}
	
	/**
	 * add set space and wrapper object space
	 */
	public Pair<Integer, Integer> objectsUsed() {
		Pair<Integer,Integer> ssp = s.objectsUsed();
		
		int noOfObjects = ssp.fst + 1;	// m nodes, 1 wrapper
		int noOfFields  = ssp.snd + 3;	// n node fields, 3 wrapper field
		return
		new Pair<Integer, Integer>(noOfObjects, noOfFields);
	}
	
	/**
	 * the static counters for construtor calls for the wrapper and the node objects
	 * <p>
	 * every wrapper objects has 3 fields: the comparator, the factory and the set data
	 */
	static int newSet  = 0;
	
	public
	Pair<Integer, Integer> objectsAllocated() {
		int nm = newSet;
		newSet = 0;
		Pair<Integer,Integer> sp = s.objectsAllocated();
		
		return
		new Pair<Integer,Integer>(nm + sp.fst, 3 * nm + sp.snd);
	}
	
	public
	String fingerprint() {
		StringBuffer res = new StringBuffer();
		res.append(this.hashCode());
		res.append(",").append(sf.hashCode());
		res.append(",").append(s.fingerprint());

		return
		res.toString();
	}	
}
