/**
 * $Id: Profile.java,v 1.2 2006/01/31 18:27:43 uwe Exp $ 
 */

package de.fhw.data.util;

import de.fhw.data.tuple.Pair;

/**
 * Interface for space profiling of a data structure
 * 
 * @author uwe
 *
 */

public
interface Profile {
	/**
	 * @return the total # of objects and the total # of fields of a value.
	 * The two results are returned as a Pair 
	 */
	Pair<Integer, Integer> objectsUsed();

	/**
	 * @return the total # of objects and the total # of fields allocated
	 * in this class and all classes used by this class since the last call
	 * of objectsAllocated.
	 * <p>
	 * This enables profiling of the # of temporarily allocated objects
	 * for intermediate results.
	 */
	Pair<Integer, Integer> objectsAllocated();
}